(in-package depots)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Exact descriptions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun depots-descs-sound (d)
  (make-ncstrips-schemas d
    (act    :var-domains ()                           :effects nil)
    (slurp  :var-domains ((?t trucks) (?l locations)) :effects nil)
    (blurp  :var-domains ((?t trucks) (?l locations)) :effects nil)
    (step   :var-domains ((?t trucks) (?l locations) (?l2 locations)) :effects nil)
    (finish :var-domains ((?t trucks) (?l locations)) :effects nil)))

(defun depots-descs-complete (d)
  (make-ncstrips-schemas d
    (act :var-domains () :effects ())
    (slurp 
     :var-domains ((?t trucks) (?l locations))
     :effects ((:precond (and)
		:reward      0
		:poss-add-list 
 		((for-all ((?b crates)) 
			  (at ?b ?l) 
		      (in ?b ?t))
		 (for-all ((?c surfaces)) 
			  (at ?c ?l) 
		      (clear ?c)))
		:poss-delete-list
		((for-all ((?b crates) (?c surfaces)) 
			  (on ?b ?c) 
		      (at ?b ?l))
		 (for-all ((?b crates) (?c surfaces)) 
			  (on ?b ?c) 
		      (on ?b ?c))
		 (for-all ((?b crates))
			  (at ?b ?l) 
		      (clear ?b))
		 (for-all ((?b crates))
			  (at ?b ?l) 
		      (at ?b ?l))))))

    (blurp 
     :var-domains ((?t trucks) (?l locations))
     :effects ((:precond (and)
		:reward      0
		:poss-add-list 
		((for-all ((?b crates) (?c surfaces)) 
			  (and (at ?c ?l) (in ?b ?t)) 
		      (on ?b ?c))
		 (for-all ((?b crates) (?c crates)) 
			  (and (in ?c ?t) (in ?b ?t)) 
		      (on ?b ?c))
		 (for-all ((?b crates)) 
			  (in ?b ?t) 
		      (clear ?b))
		 (for-all ((?b crates)) 
			  (in ?b ?t) 
		      (at ?b ?l)))
		:poss-delete-list
		((for-all ((?b crates)) 
			  (in ?b ?t) 
		      (in ?b ?t))
		 (for-all ((?c surfaces)) 
			  (at ?c ?l) 
		      (clear ?c))))))

    (step
     :var-domains ((?t trucks) (?l locations) (?l2 locations))
     :effects ((:precond (and)
		:reward     0
		:add-list      ((at ?t ?l2))
		:delete-list   ((at ?t ?l))
		:poss-add-list 
 		((for-all ((?b crates)) 
			  (at ?b ?l) 
		      (in ?b ?t))
		 (for-all ((?c surfaces)) 
			  (at ?c ?l) 
		      (clear ?c))
		 (for-all ((?b crates) (?c surfaces)) 
			  (and (at ?c ?l) (in ?b ?t)) 
		      (on ?b ?c))
		 (for-all ((?b crates) (?c surfaces)) 
			  (and (at ?c ?l) (at ?b ?l)) 
		      (on ?b ?c))
		 (for-all ((?b crates) (?c crates)) 
			  (and (in ?c ?t) (in ?b ?t)) 
		      (on ?b ?c))
		 (for-all ((?b crates)) 
			  (in ?b ?t) 
		      (clear ?b))
		 (for-all ((?b crates)) 
			  (in ?b ?t) 
		      (at ?b ?l)))

		:poss-delete-list
		((for-all ((?b crates) (?c surfaces)) 
			  (on ?b ?c) 
		      (on ?b ?c))
		 (for-all ((?b crates) (?c surfaces)) 
			  (on ?b ?c) 
		      (at ?b ?l))
		 (for-all ((?b crates) (?c surfaces)) 
			  (and (at ?c ?l) (on ?b ?c)) 
		      (on ?b ?c))
		 (for-all ((?b crates))
			  (at ?b ?l) 
		      (clear ?b))
		 (for-all ((?b crates))
			  (at ?b ?l) 
		      (at ?b ?l))
		 (for-all ((?b crates)) 
			  (in ?b ?t) 
		      (in ?b ?t))
		 (for-all ((?c surfaces)) 
			  (at ?c ?l) 
		      (clear ?c))))))


    (finish
     :var-domains ((?t trucks) (?l locations))
     :effects ((:precond (and)
		:reward     0
		:poss-add-list 
 		((for-all ((?b crates)) 
			  (at ?b ?l) 
		      (in ?b ?t))
		 (for-all ((?c surfaces)) 
			  (at ?c ?l) 
		      (clear ?c))
		 (for-all ((?b crates) (?c surfaces)) 
			  (and (at ?c ?l) (in ?b ?t)) 
		      (on ?b ?c))
		 (for-all ((?b crates) (?c surfaces)) 
			  (and (at ?c ?l) (at ?b ?l)) 
		      (on ?b ?c))
		 (for-all ((?b crates) (?c crates)) 
			  (and (in ?c ?t) (in ?b ?t)) 
		      (on ?b ?c))
		 (for-all ((?b crates)) 
			  (and (in ?b ?t)) 
		      (at ?b ?l))
		 (for-all ((?b crates)) 
			  (and (in ?b ?t)) 
		      (clear ?b)))

		:poss-delete-list
		((for-all ((?b crates) (?c surfaces)) 
			  (on ?b ?c) 
		      (at ?b ?l))
		 (for-all ((?b crates) (?c surfaces)) 
			  (on ?b ?c) 
		      (on ?b ?c))
		 (for-all ((?b crates) (?c surfaces)) 
			  (and (at ?c ?l) (on ?b ?c)) 
		      (on ?b ?c))
		 (for-all ((?b crates))
			  (at ?b ?l) 
		      (clear ?b))
		 (for-all ((?b crates))
			  (at ?b ?l) 
		      (at ?b ?l))
		 (for-all ((?b crates)) 
			  (in ?b ?t) 
		      (in ?b ?t))
		 (for-all ((?c surfaces)) 
			  (at ?c ?l) 
		      (clear ?c))))))))
		
		
(defun depots-act-complete (cset)
  (declare (ignore cset))
  0
  )

    



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Subsumption check key
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#|(defun subsumption-key (s)
  (if (listp s)
      s
    (let (loc dir)
      (do-elements (l (conjuncts (item 0 (disjuncts (formula s)))))
	(unless (typep l 'negation)
	  (ecase (prop-symbol l)
	    (at (setf loc (prop-args l)))
	    (vert (setf dir 'v))
	    (horiz (setf dir 'h)))))
      (list loc dir))))|#



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Lower and upper heuristics for Act
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#|

(defun ns-act-complete (cset &aux (d (pss-domain cset)))
  (let ((goal (prop-args (first (conjuncts (formula (goal d)))))))
    (* (good-move-cost d) (neg-manhattan-dist goal (get-loc cset)))))

(defun ns-act-sound (sset &aux (d (pss-domain sset)))
  (let ((goal (prop-args (first (conjuncts (formula (goal d)))))))
    (* (bad-move-cost d) (neg-manhattan-dist goal (get-loc sset)))))

|#

  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Helpers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#|(defun get-loc (s)
  (prop-args
   (find-element (conjuncts (item 0 (disjuncts (formula s))))
		 #'(lambda (p) (eq (prop-symbol p) 'at)))))|#
	
      
  
  