(defpackage test-depots
  (:use
   cl
   utils
   set
   ltk-obs
   hla
   depots
   prop-logic
   ))

(in-package test-depots)

(setf c (make-hash-subsumption-checker #'identity)
      )

(defun use-world (d2)
  (setf
      d d2
      h (make-flat-prop-hierarchy d2)
      p (make-instance '<prop-abstract-planning-problem>
	  :preprocess t :admissible-heuristic #'depots-act-complete :planning-problem d2 :hierarchy h
	  :subsumption-checker c)
      g (make-depots-hierarchy d2)
      q (make-instance '<prop-abstract-planning-problem>
	  :preprocess t :admissible-heuristic #'depots-act-complete :planning-problem d2 :hierarchy g
	  :complete-desc-schemas (depots-descs-complete d2)  ;:guarantee-heuristic (constantly -100000000) 
	  :sound-desc-schemas (depots-descs-sound d2) :subsumption-checker c)))


(defun complete-reward (x y z)
  (declare (ignore x z))
  y)

(defun offline-tests ()
  (flet ((check (p)
	   (assert (hla:succeeds? d (subseq p 0 (1- (length p)))))))
    ;; (format t "~&------------------------------------------------~&AHSS~&")
    ;; (time (check (ahss q '-infty)))
    (format t "~&------------------------------------------------~&AHA*~&")
    (time (check (aha* q)))
    (format t "~&------------------------------------------------~&Flat A*~&")
    (time (check (aha* p)))))


(defun htest (nr)
  (time (print (rl:evaluate d (ahrta*-agent q #'complete-reward nr :max-num-actions 5 ) :num-steps 200))))

(defun ftest (nr)
  (time (print (rl:evaluate d (ahrta*-agent p #'complete-reward nr :max-num-actions 5 ) :num-steps 200))))
  
(defun online-tests ()
  (dolist (nr '(50 200 500))
    (format t "~&-----------------------------------------------~&Flat ~a~&" nr)
    (ftest nr)
    (format t "~&-----------------------------------------------~&Hierarchical ~a~&" nr)
    (htest nr)
    ))