(in-package asdf)

(asdf:defsystem "lookahead-sys"
    :depends-on ("hrl")
    :components ((:module "lookahead-mod" :pathname "lookahead/"
			  :components
			  ((:file "lookahead")
			   (:file "planning-problem" :depends-on ("lookahead"))
			   (:file "hierarchy" :depends-on ("lookahead" "planning-problem"))
			   (:file "description" :depends-on ("lookahead"))
			   (:file "variable-hierarchy" :depends-on ("description" "hierarchy"))
			   (:file "abstract-planning-problem" :depends-on ("planning-problem" "hierarchy" "description"))
			   (:file "subsumption" :depends-on ("description"))
			   (:module "lookahead-mod2" :pathname "lookahead/" :depends-on ("abstract-planning-problem" "subsumption")
				    :components
				    ((:file "abstract-lookahead-tree")
				     (:file "nodes" :depends-on ("abstract-lookahead-tree"))
				     (:file "meta" :depends-on ("nodes"))
				     (:file "hrt" :depends-on ("abstract-lookahead-tree"))
				     (:file "ahrta" :depends-on ("abstract-lookahead-tree"))
				     (:file "offline" :depends-on ("nodes"))))
			   (:module "prop"
				    :depends-on ("lookahead-mod2")
				    :components
				    ((:file "csp")
				     (:file "prop-domain" :depends-on ("csp"))
				     (:file "ncstrips" :depends-on ("prop-domain"))
				     (:file "prop-hierarchy" :depends-on ("prop-domain"))
				     (:file "prop-abstract-planning-problem" :depends-on ("prop-domain"))))))
					    
		 (:module "envs" :depends-on ("lookahead-mod")
			  :components
			  ((:module "blocks"
				    :components ((:file "blocks-ceiling")
						 (:file "hierarchy" :depends-on ("blocks-ceiling"))
						 (:file "descriptions" :depends-on ("blocks-ceiling"))
						 (:file "subsumption" :depends-on ("blocks-ceiling"))))
			   
			   (:module "nav-switch" 
				    :components ((:file "nav-switch")
						 (:file "hierarchy")
						 (:file "descriptions")))
							      
			   
			   
			   (:module "forage" :components ((:file "forage")))))
		 
		 )) 
							

