(defpackage test-strat-hlearn
  (:use 
   cl
   set
   s-env
   prob
   utils
   maxq)
  (:import-from    
   maxq
   <var-val-goal-language>
   make-var-val-set-goal
   make-var-var-goal
   make-var-specs
   
   initial-hierarchy
   greedy-hierarchy-learning

   ))

(in-package test-strat-hlearn)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; load trajectories
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(with-open-file (f "scratch/barracks-trajectories" :direction :input)
  (defvar *traj* (read f)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; helper functions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun singletons (s) (make-instance '<subsets-of-size> :base-set s :size 1))

(defparameter *peas* 1)
(defparameter *pid* 0)

(defun peasant-loc (s)
  (get-unit-loc *peas* s))

(defun peasant-status (s)
  (get-unit-status *peas* s))

(defun have-barracks (s)
  (to-boolean (units-belonging-to-of-type *pid* 'barracks s)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set up params for greedy hierarchy learning
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setf locs '((16 20) (24 16) (18 5) (9 19) (2 11) (5 3))
      prim 
      (cons 'noop
	    (mapcar #'(lambda (a) (list (cons *peas* a)))
		    (append
		     '((build barracks) (harvest gold) (harvest wood)
		       (dropoff))
		     (mapcar #'(lambda (l) `(move-towards ,l)) locs))))
		
      vs (make-var-specs 
	  (pos #'peasant-loc (singletons locs) 1000)
	  (status #'peasant-status (singletons *statuses*) (size *statuses*))
	  (have-barracks #'have-barracks '(t) 2))
      
      tl (make-instance '<var-val-goal-language>
	   :var-specs vs)
      h (initial-hierarchy tl prim)
      )




