(in-package dmcmc)

(defun polynomial-decay (b &optional (a 1))
  "polynomial-decay B &optional (A 1)
Return the decay rate 1/(k+a)^b"
  #'(lambda (k) (expt (+ k a) (- b))))

(defun exponential-decay (c)
  "exponential-decay C
Return the decay rate c^k"
  (assert (< 0 c 1))
  #'(lambda (k) (expt c k)))

(defun fixed-lag (l)
  "fixed-lag L.  Return a uniform distribution over the last L timesteps."
  (make-array l :element-type 'fixnum :initial-element 1))

(defun fixed-window (decay l)
  "fixed-window DECAY L.  Return a truncated version of DECAY to L steps."
  (mapset 'vector #'(lambda (i) (evaluate decay i)) l))
