(defpackage test-diff-fn
  (:use 
   diff-fn
   cl
   value-fn
   utils)
  )

(in-package test-diff-fn)

(setf d1 (make-instance '<tabular-difference-function>
	   :states 3
	   :table (make-array '(3 3) :element-type 'float
			      :initial-contents '((.2 .4 3.0) (-.3 0.0 1.1) (1.0 2.3 4.2))))
      d2 (make-instance '<tabular-difference-function>
	   :states '(foo bar)))

(defun defined (f s1 s2)
  (handler-case
      (progn 
	(difference f s1 s2)
	t)
    (unknown-difference ()
      nil)))

(do-tests "Basic ops on tabular difference functions"
  (difference d1 1 2) 1.1
  (difference d1 2 1) 2.3
  (progn
    (update d1 0 1 1 .5)
    (difference d1 0 1)) 
  .7
  
  (difference d1 1 2) 1.1
  (defined d2 'foo 'bar) nil
  
  (progn
    (update d2 'foo 'bar 6 .1)
    (defined d2 'foo 'bar))
  t
  
  (defined d2 'bar 'foo) nil
  
  (difference d2 'foo 'bar) .6
  (difference d2 'bar 'foo 10) 10)
  


    
   
   